---
# https://support.apple.com/en-us/HT208394
# https://gist.github.com/ErikAugust/724d4a969fb2c6ae1bbd7b2a9e3d4bb6
# https://twitter.com/pwnallthethings/status/948693961358667777
# https://github.com/Eugnis/spectre-attack/blob/master/Source.c

- name: download speculative execution sample code
  ansible.builtin.get_url:
    url: https://gist.githubusercontent.com/jedisct1/3bbb6e50b768968c30629bf734ea49c6/raw/6ede3c9a3356a4a55a27febaf38157897c4fed09/spectre.c
    dest: /tmp/spectre.c
    owner: nobody
    mode: '0600'

- name: compile sample code
  ansible.builtin.command: gcc -std=c99 -O0 spectre.c -o spectre
  args:
    chdir: /tmp
    creates: /tmp/spectre

- name: run sample code
  ansible.builtin.command: ./spectre  # noqa 301
  args:
    chdir: /tmp
  # Failed to set permissions on the temporary files Ansible needs to create when becoming an unprivileged user
  #   (rc: 1, err: chown: /tmp/ansible-tmp-1515230731.18-128064885271625/: Operation not permitted\nchown:
  #   /tmp/ansible-tmp-1515230731.18-128064885271625/command.py: Operation not permitted\n}). For information
  #   on working around this, see https://docs.ansible.com/ansible/become.html#becoming-an-unprivileged-user
  # become: yes
  # become_user: nobody
  register: spectre
  ignore_errors: true

- name: Debug | spectre
  ansible.builtin.debug: var=spectre
